<?php
namespace Magento\Quote\Api\Data;

/**
 * ExtensionInterface class for @see \Magento\Quote\Api\Data\AddressInterface
 */
interface AddressExtensionInterface extends \Magento\Framework\Api\ExtensionAttributesInterface
{
    /**
     * @return string|null
     */
    public function getPickupLocationCode();

    /**
     * @param string $pickupLocationCode
     * @return $this
     */
    public function setPickupLocationCode($pickupLocationCode);

    /**
     * @return \Magento\SalesRule\Api\Data\RuleDiscountInterface[]|null
     */
    public function getDiscounts();

    /**
     * @param \Magento\SalesRule\Api\Data\RuleDiscountInterface[] $discounts
     * @return $this
     */
    public function setDiscounts($discounts);

    /**
     * @return string|null
     */
    public function getMspostnordAvailableAddons();

    /**
     * @param string $mspostnordAvailableAddons
     * @return $this
     */
    public function setMspostnordAvailableAddons($mspostnordAvailableAddons);

    /**
     * @return string|null
     */
    public function getMspostnordAvailableServicePoints();

    /**
     * @param string $mspostnordAvailableServicePoints
     * @return $this
     */
    public function setMspostnordAvailableServicePoints($mspostnordAvailableServicePoints);

    /**
     * @return string|null
     */
    public function getMspostnordLongDescription();

    /**
     * @param string $mspostnordLongDescription
     * @return $this
     */
    public function setMspostnordLongDescription($mspostnordLongDescription);

    /**
     * @return string|null
     */
    public function getMspostnordSelectedAddons();

    /**
     * @param string $mspostnordSelectedAddons
     * @return $this
     */
    public function setMspostnordSelectedAddons($mspostnordSelectedAddons);

    /**
     * @return string|null
     */
    public function getMspostnordSelectedServicePoint();

    /**
     * @param string $mspostnordSelectedServicePoint
     * @return $this
     */
    public function setMspostnordSelectedServicePoint($mspostnordSelectedServicePoint);

    /**
     * @return string|null
     */
    public function getMspostnordShipmentOptionId();

    /**
     * @param string $mspostnordShipmentOptionId
     * @return $this
     */
    public function setMspostnordShipmentOptionId($mspostnordShipmentOptionId);

    /**
     * @return string|null
     */
    public function getMspostnordState();

    /**
     * @param string $mspostnordState
     * @return $this
     */
    public function setMspostnordState($mspostnordState);
}
