<?php
namespace Magento\Quote\Api\Data;

/**
 * Extension class for @see \Magento\Quote\Api\Data\ShippingMethodInterface
 */
class ShippingMethodExtension extends \Magento\Framework\Api\AbstractSimpleObject implements ShippingMethodExtensionInterface
{
    /**
     * @return string|null
     */
    public function getMspostnordAvailableAddons()
    {
        return $this->_get('mspostnord_available_addons');
    }

    /**
     * @param string $mspostnordAvailableAddons
     * @return $this
     */
    public function setMspostnordAvailableAddons($mspostnordAvailableAddons)
    {
        $this->setData('mspostnord_available_addons', $mspostnordAvailableAddons);
        return $this;
    }

    /**
     * @return string|null
     */
    public function getMspostnordAvailableServicePoints()
    {
        return $this->_get('mspostnord_available_service_points');
    }

    /**
     * @param string $mspostnordAvailableServicePoints
     * @return $this
     */
    public function setMspostnordAvailableServicePoints($mspostnordAvailableServicePoints)
    {
        $this->setData('mspostnord_available_service_points', $mspostnordAvailableServicePoints);
        return $this;
    }

    /**
     * @return string|null
     */
    public function getMspostnordLongDescription()
    {
        return $this->_get('mspostnord_long_description');
    }

    /**
     * @param string $mspostnordLongDescription
     * @return $this
     */
    public function setMspostnordLongDescription($mspostnordLongDescription)
    {
        $this->setData('mspostnord_long_description', $mspostnordLongDescription);
        return $this;
    }

    /**
     * @return string|null
     */
    public function getMspostnordSelectedAddons()
    {
        return $this->_get('mspostnord_selected_addons');
    }

    /**
     * @param string $mspostnordSelectedAddons
     * @return $this
     */
    public function setMspostnordSelectedAddons($mspostnordSelectedAddons)
    {
        $this->setData('mspostnord_selected_addons', $mspostnordSelectedAddons);
        return $this;
    }

    /**
     * @return string|null
     */
    public function getMspostnordSelectedServicePoint()
    {
        return $this->_get('mspostnord_selected_service_point');
    }

    /**
     * @param string $mspostnordSelectedServicePoint
     * @return $this
     */
    public function setMspostnordSelectedServicePoint($mspostnordSelectedServicePoint)
    {
        $this->setData('mspostnord_selected_service_point', $mspostnordSelectedServicePoint);
        return $this;
    }

    /**
     * @return string|null
     */
    public function getMspostnordShipmentOptionId()
    {
        return $this->_get('mspostnord_shipment_option_id');
    }

    /**
     * @param string $mspostnordShipmentOptionId
     * @return $this
     */
    public function setMspostnordShipmentOptionId($mspostnordShipmentOptionId)
    {
        $this->setData('mspostnord_shipment_option_id', $mspostnordShipmentOptionId);
        return $this;
    }

    /**
     * @return string|null
     */
    public function getMspostnordIsRecommended()
    {
        return $this->_get('mspostnord_is_recommended');
    }

    /**
     * @param string $mspostnordIsRecommended
     * @return $this
     */
    public function setMspostnordIsRecommended($mspostnordIsRecommended)
    {
        $this->setData('mspostnord_is_recommended', $mspostnordIsRecommended);
        return $this;
    }

    /**
     * @return string|null
     */
    public function getMspostnordDeliveryEstimateText()
    {
        return $this->_get('mspostnord_delivery_estimate_text');
    }

    /**
     * @param string $mspostnordDeliveryEstimateText
     * @return $this
     */
    public function setMspostnordDeliveryEstimateText($mspostnordDeliveryEstimateText)
    {
        $this->setData('mspostnord_delivery_estimate_text', $mspostnordDeliveryEstimateText);
        return $this;
    }
}
