<?php

declare(strict_types=1);

namespace Mediastrategi\PostNord\Api\Data;

interface OrderDataInterface extends \Magento\Framework\Api\ExtensibleDataInterface
{
    const ID = 'id';
    const ORDER_ID = 'order_id';
    const ORDER_DATA = 'order_data';

    /**
     * Get id
     *
     * @return int|null
     */
    public function getId(): ?int;

    /**
     * Set id
     *
     * @param int $id
     *
     * @return \Mediastrategi\PostNord\Api\Data\OrderDataInterface
     */
    public function setId(int $id): OrderDataInterface;

    /**
     * Get Order Id
     *
     * @return int|null
     */
    public function getOrderId(): ?int;

    /**
     * Set Order Id
     *
     * @param int $orderId
     *
     * @return \Mediastrategi\PostNord\Api\Data\OrderDataInterface
     */
    public function setOrderId(int $orderId): OrderDataInterface;

    /**
     * Retrieve existing extension attributes object or create a new one.
     *
     * @return \Mediastrategi\PostNord\Api\Data\OrderDataExtensionInterface|null
     */
    public function getExtensionAttributes();

    /**
     * Set an extension attributes object.
     *
     * @param \Mediastrategi\PostNord\Api\Data\OrderDataExtensionInterface $extensionAttributes
     *
     * @return PersistentQuoteInterface
     */
    public function setExtensionAttributes(
        \Mediastrategi\PostNord\Api\Data\OrderDataExtensionInterface $extensionAttributes
    ): OrderDataInterface;

    /**
     * Get Order Data
     *
     * @return string|null
     */
    public function getOrderData(): ?string;

    /**
     * Set Order Data
     *
     * @param string $orderData
     *
     * @return OrderDataInterface
     */
    public function setOrderData(string $orderData): OrderDataInterface;
}
