<?php

declare(strict_types=1);

namespace Mediastrategi\PostNord\Api\Data;

interface PersistentQuoteInterface extends \Magento\Framework\Api\ExtensibleDataInterface
{
    const ID = 'id';
    const QUOTE_ID = 'quote_id';
    const QUOTE_DATA = 'quote_data';

    /**
     * Get id
     *
     * @return int|null
     */
    public function getId(): ?int;

    /**
     * Set id
     *
     * @param int $id
     *
     * @return \Mediastrategi\PostNord\Api\Data\PersistentQuoteInterface
     */
    public function setId(int $id): PersistentQuoteInterface;

    /**
     * Get quote_id
     *
     * @return int|null
     */
    public function getQuoteId(): ?int;

    /**
     * Set quote_id
     *
     * @param int $quoteId
     *
     * @return \Mediastrategi\PostNord\Api\Data\PersistentQuoteInterface
     */
    public function setQuoteId(int $quoteId): PersistentQuoteInterface;

    /**
     * Retrieve existing extension attributes object or create a new one.
     *
     * @return \Mediastrategi\PostNord\Api\Data\PersistentQuoteExtensionInterface|null
     */
    public function getExtensionAttributes();

    /**
     * Set an extension attributes object.
     *
     * @param  \Mediastrategi\PostNord\Api\Data\PersistentQuoteExtensionInterface  $extensionAttributes
     *
     * @return PersistentQuoteInterface
     */
    public function setExtensionAttributes(
        \Mediastrategi\PostNord\Api\Data\PersistentQuoteExtensionInterface $extensionAttributes
    ): PersistentQuoteInterface;

    /**
     * Get quote_data
     *
     * @return string|null
     */
    public function getQuoteData(): ?string;

    /**
     * Set quote_data
     *
     * @param  string  $quoteData
     *
     * @return PersistentQuoteInterface
     */
    public function setQuoteData(string $quoteData): PersistentQuoteInterface;
}
