<?php

declare(strict_types=1);

namespace Mediastrategi\PostNord\Api\Data;

interface ScheduleInterface extends \Magento\Framework\Api\ExtensibleDataInterface
{
    const SCHEDULE_ID = 'schedule_id';
    const SCHEDULE_ADDED = 'schedule_added';
    const SCHEDULE_STATUS = 'schedule_status';
    const SCHEDULE_LOG = 'schedule_log';

    const OK = 0;
    const ERROR = 1;

    /**
     * Get schedule_id
     * @return string|null
     */
    public function getScheduleId();

    /**
     * Set schedule_id
     *
     * @param  string  $scheduleId
     *
     * @return \Mediastrategi\PostNord\Api\Data\ScheduleInterface
     */
    public function setScheduleId($scheduleId);

    /**
     * Get schedule_status
     * @return string|null
     */
    public function getScheduleStatus();

    /**
     * Set schedule_status
     *
     * @param  string  $scheduleStatus
     *
     * @return \Mediastrategi\PostNord\Api\Data\ScheduleInterface
     */
    public function setScheduleStatus($scheduleStatus);

    /**
     * Retrieve existing extension attributes object or create a new one.
     * @return \Mediastrategi\PostNord\Api\Data\ScheduleExtensionInterface|null
     */
    public function getExtensionAttributes();

    /**
     * Set an extension attributes object.
     *
     * @param  \Mediastrategi\PostNord\Api\Data\ScheduleExtensionInterface  $extensionAttributes
     *
     * @return $this
     */
    public function setExtensionAttributes(
        \Mediastrategi\PostNord\Api\Data\ScheduleExtensionInterface $extensionAttributes
    );

    /**
     * Get schedule_log
     * @return string|null
     */
    public function getScheduleLog();

    /**
     * Set schedule_log
     *
     * @param  string  $scheduleLog
     *
     * @return \Mediastrategi\PostNord\Api\Data\ScheduleInterface
     */
    public function setScheduleLog($scheduleLog);

    /**
     * Get schedule_added
     * @return string|null
     */
    public function getScheduleAdded();

    /**
     * Set schedule_added
     *
     * @param  string  $scheduleAdded
     *
     * @return \Mediastrategi\PostNord\Api\Data\ScheduleInterface
     */
    public function setScheduleAdded($scheduleAdded);
}
