<?php

declare(strict_types=1);

namespace Mediastrategi\PostNord\Api;

interface PersistentQuoteRepositoryInterface
{
    /**
     * Save PersistentQuote
     *
     * @param  \Mediastrategi\PostNord\Api\Data\PersistentQuoteInterface  $persistentQuote
     *
     * @return \Mediastrategi\PostNord\Api\Data\PersistentQuoteInterface
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function save(
        \Mediastrategi\PostNord\Api\Data\PersistentQuoteInterface $persistentQuote
    );

    /**
     * Retrieve PersistentQuote
     *
     * @param  string  $persistentquoteId
     *
     * @return \Mediastrategi\PostNord\Api\Data\PersistentQuoteInterface
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function get($persistentquoteId);

    /**
     * Retrieve PersistentQuote matching the specified criteria.
     *
     * @param  \Magento\Framework\Api\SearchCriteriaInterface  $searchCriteria
     *
     * @return \Magento\Framework\Api\SearchResults
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function getList(
        \Magento\Framework\Api\SearchCriteriaInterface $searchCriteria
    );

    /**
     * Delete PersistentQuote
     *
     * @param  \Mediastrategi\PostNord\Api\Data\PersistentQuoteInterface  $persistentQuote
     *
     * @return bool true on success
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function delete(
        \Mediastrategi\PostNord\Api\Data\PersistentQuoteInterface $persistentQuote
    );

    /**
     * Delete PersistentQuote by ID
     *
     * @param  string  $persistentquoteId
     *
     * @return bool true on success
     * @throws \Magento\Framework\Exception\NoSuchEntityException
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function deleteById($persistentquoteId);
}
