<?php

declare(strict_types=1);

namespace Mediastrategi\PostNord\Block\System\Config\Form\Field;

class AdminUser extends \Magento\Config\Block\System\Config\Form\Field
{
    /**
     * @var \Magento\Authorization\Model\Role
     */
    private $roleModel;

    /**
     * @var \Magento\Authorization\Model\Role
     */
    private $userModel;

    public function __construct(
        \Magento\Backend\Block\Template\Context $context,
        \Magento\Authorization\Model\Role $roleModel,
        \Magento\User\Model\User $userModel
    ) {
        parent::__construct($context);
        $this->roleModel = $roleModel;
        $this->userModel = $userModel;
    }

    public function toOptionArray(): array
    {
        $users = [];
        $role = $this->roleModel->load(
            'Administrators',
            'role_name'
        );
        if ($role->getId()) {
            if ($userIds = $role->getRoleUsers()) {
                foreach ($userIds as $userId) {
                    $user = $this->userModel->load($userId);
                    if ($user->getId()) {
                        $users[] = [
                            'label' => $user->getUsername(),
                            'value' => $user->getUsername(),
                        ];
                    }
                }
            }
        }
        return $users;
    }
}
