<?php

declare(strict_types=1);

namespace Mediastrategi\PostNord\Block\System\Config\Form\Field;

class Changelog extends \Magento\Config\Block\System\Config\Form\Field
{
    /**
     * @var \Mediastrategi\PostNord\Helper\Meta
     */
    private $metaHelper;

    public function __construct(
        \Magento\Backend\Block\Template\Context $context,
        \Mediastrategi\PostNord\Helper\Meta $metaHelper
    ) {
        parent::__construct($context);
        $this->metaHelper = $metaHelper;
    }

    /**
     * @SuppressWarnings(PHPMD.UnusedFormalParameter)
     * @SuppressWarnings(PHPMD.CamelCaseMethodName)
     * phpcs:disable PSR2.Methods.MethodDeclaration.Underscore
     * phpcs:disable Generic.CodeAnalysis.UnusedFunctionParameter
     */
    protected function _getElementHtml(
        \Magento\Framework\Data\Form\Element\AbstractElement $element
    ): string {
        $changelog = $this->metaHelper->getChangelog();
        if ($changelog) {
            $html = '<ol style="list-style: none outside none;">';
            foreach ($changelog as $version => $description) {
                $html .= sprintf(
                    '<li><strong>%s</strong> <span>%s</span>',
                    $version,
                    $description
                );
            }
            $html .= '</ol>';
            return $html;
        } else {
            return (string) __('Failed to get changelog!');
        }
    }
}
