<?php

declare(strict_types=1);

namespace Mediastrategi\PostNord\Block\System\Config\Form\Field;

class Status extends \Magento\Config\Block\System\Config\Form\Field
{
    /**
     * @var \Mediastrategi\PostNord\Helper\Meta
     */
    private $metaHelper;

    public function __construct(
        \Magento\Backend\Block\Template\Context $context,
        \Mediastrategi\PostNord\Helper\Meta $metaHelper
    ) {
        parent::__construct($context);
        $this->metaHelper = $metaHelper;
    }

    /**
     * @SuppressWarnings(PHPMD.UnusedFormalParameter)
     * @SuppressWarnings(PHPMD.CamelCaseMethodName)
     * phpcs:disable PSR2.Methods.MethodDeclaration.Underscore
     * phpcs:disable Generic.CodeAnalysis.UnusedFunctionParameter
     */
    protected function _getElementHtml(
        \Magento\Framework\Data\Form\Element\AbstractElement $element
    ): string {
        $html = '';
        if (
            $errors =
                $this->metaHelper->getConfigurationErrors()
        ) {
            $html .= '<strong>' . __('Errors:')
                     . '</strong><ul style="'
                     . 'margin: 10px 0; list-style: inside circle none; color: red; font-weight: bold;"><li>'
                     . implode('</li><li>', $errors) . '</li></ul>';
        } else {
            $html .= '<strong style="color: green; font-weight: bold;">' . __('Site Configuration OK') . '</strong>';
        }
        return $html;
    }
}
