<?php

declare(strict_types=1);

namespace Mediastrategi\PostNord\Controller\Adminhtml\Automation;

class Ignore extends \Magento\Backend\App\Action implements \Magento\Framework\App\Action\HttpGetActionInterface
{
    /**
     * Authorization level of a basic admin session
     */
    const ADMIN_RESOURCE = 'Mediastrategi_PostNord::automation';

    /**
     * \Mediastrategi\PostNord\Helper\OrderData
     */
    private $orderDataHelper;

    /**
     * @var \Magento\Sales\Api\OrderRepositoryInterface
     */
    private $orderRepository;

    /**
     * @var \Psr\Log\LoggerInterface
     */
    private $logger;

    public function __construct(
        \Magento\Backend\App\Action\Context $context,
        \Mediastrategi\PostNord\Helper\OrderData $orderDataHelper,
        \Magento\Sales\Api\OrderRepositoryInterface $orderRepository,
        \Psr\Log\LoggerInterface $logger
    ) {
        parent::__construct($context);
        $this->orderDataHelper = $orderDataHelper;
        $this->orderRepository = $orderRepository;
        $this->logger          = $logger;
    }

    public function execute(): \Magento\Framework\Controller\ResultInterface
    {
        // Update order data
        $orderId =
            (int) $this->getRequest()->getParam('order_id');
        $orderData = $this->orderDataHelper->readData(
            $orderId
        );
        $orderData['ignoreAutomation'] =
            empty($orderData['ignoreAutomation']);
        $this->orderDataHelper->update(
            $orderId,
            $orderData
        );

        return $this->resultRedirectFactory->create()->setPath('sales/order/view/order_id/' . $orderId);
    }
}
