<?php

declare(strict_types=1);

namespace Mediastrategi\PostNord\Controller\Adminhtml\Misc;

use Magento\Backend\App\Action;
use Magento\Backend\Model\View\Result\Page;
use Magento\Framework\App\Action\HttpGetActionInterface;
use Magento\Framework\Controller\ResultFactory;
use Magento\Framework\Controller\ResultInterface;

class Automation extends Action implements HttpGetActionInterface
{
    /**
     * Authorization level of a basic admin session
     */
    public const ADMIN_RESOURCE = 'Mediastrategi_PostNord::automation';

    /**
     * Execute action based on request and return result
     *
     * @return ResultInterface
     */
    public function execute()
    {
        /** @var Page $resultPage */
        $resultPage = $this->resultFactory->create(ResultFactory::TYPE_PAGE);
        $resultPage->setActiveMenu('Mediastrategi_PostNord::automation');
        $resultPage->getConfig()->getTitle()->prepend(__('Run Automation'));

        return $resultPage;
    }
}
