<?php

declare(strict_types=1);

namespace Mediastrategi\PostNord\Model\Data;

use Mediastrategi\PostNord\Api\Data\OrderDataInterface;

class OrderData extends \Magento\Framework\Api\AbstractExtensibleObject implements OrderDataInterface
{
    public function getId(): ?int
    {
        return $this->_get(self::ID);
    }

    public function setId(int $id): OrderDataInterface
    {
        return $this->setData(
            self::ID,
            $id
        );
    }

    public function getOrderId(): ?int
    {
        return $this->_get(self::ORDER_ID);
    }

    public function setOrderId(int $orderId): OrderDataInterface
    {
        return $this->setData(
            self::ORDER_ID,
            $orderId
        );
    }

    public function getExtensionAttributes(): ?\Mediastrategi\PostNord\Api\Data\OrderDataExtensionInterface
    {
        return $this->_getExtensionAttributes();
    }

    public function setExtensionAttributes(
        \Mediastrategi\PostNord\Api\Data\OrderDataExtensionInterface $extensionAttributes
    ): OrderDataInterface {
        return $this->_setExtensionAttributes($extensionAttributes);
    }

    public function getOrderData(): ?string
    {
        return $this->_get(self::ORDER_DATA);
    }

    public function setOrderData(string $orderData): OrderDataInterface
    {
        return $this->setData(
            self::ORDER_DATA,
            $orderData
        );
    }
}
