<?php

declare(strict_types=1);

namespace Mediastrategi\PostNord\Model\Data;

use Mediastrategi\PostNord\Api\Data\PersistentQuoteInterface;

class PersistentQuote extends \Magento\Framework\Api\AbstractExtensibleObject implements PersistentQuoteInterface
{
    public function getId(): ?int
    {
        return $this->_get(self::ID);
    }

    public function setId(int $id): PersistentQuoteInterface
    {
        return $this->setData(
            self::ID,
            $id
        );
    }

    public function getQuoteId(): ?int
    {
        return $this->_get(self::QUOTE_ID);
    }

    public function setQuoteId(int $quoteId): PersistentQuoteInterface
    {
        return $this->setData(
            self::QUOTE_ID,
            $quoteId
        );
    }

    public function getExtensionAttributes(): ?\Mediastrategi\PostNord\Api\Data\PersistentQuoteExtensionInterface
    {
        return $this->_getExtensionAttributes();
    }

    public function setExtensionAttributes(
        \Mediastrategi\PostNord\Api\Data\PersistentQuoteExtensionInterface $extensionAttributes
    ): PersistentQuoteInterface {
        return $this->_setExtensionAttributes($extensionAttributes);
    }

    public function getQuoteData(): ?string
    {
        return $this->_get(self::QUOTE_DATA);
    }

    public function setQuoteData(string $quoteData): PersistentQuoteInterface
    {
        return $this->setData(
            self::QUOTE_DATA,
            $quoteData
        );
    }
}
