<?php

declare(strict_types=1);

namespace Mediastrategi\PostNord\Model\Data;

use Mediastrategi\PostNord\Api\Data\ScheduleInterface;

class Schedule extends \Magento\Framework\Api\AbstractExtensibleObject implements ScheduleInterface
{
    /**
     * Get schedule_id
     * @return string|null
     */
    public function getScheduleId()
    {
        return $this->_get(self::SCHEDULE_ID);
    }

    /**
     * Set schedule_id
     *
     * @param  string  $scheduleId
     *
     * @return \Mediastrategi\PostNord\Api\Data\ScheduleInterface
     */
    public function setScheduleId($scheduleId)
    {
        return $this->setData(self::SCHEDULE_ID, $scheduleId);
    }

    /**
     * Get schedule_status
     * @return string|null
     */
    public function getScheduleStatus()
    {
        return $this->_get(self::SCHEDULE_STATUS);
    }

    /**
     * Set schedule_status
     *
     * @param  string  $scheduleStatus
     *
     * @return \Mediastrategi\PostNord\Api\Data\ScheduleInterface
     */
    public function setScheduleStatus($scheduleStatus)
    {
        return $this->setData(self::SCHEDULE_STATUS, $scheduleStatus);
    }

    /**
     * Retrieve existing extension attributes object or create a new one.
     * @return \Mediastrategi\PostNord\Api\Data\ScheduleExtensionInterface|null
     */
    public function getExtensionAttributes()
    {
        return $this->_getExtensionAttributes();
    }

    /**
     * Set an extension attributes object.
     *
     * @param  \Mediastrategi\PostNord\Api\Data\ScheduleExtensionInterface  $extensionAttributes
     *
     * @return $this
     */
    public function setExtensionAttributes(
        \Mediastrategi\PostNord\Api\Data\ScheduleExtensionInterface $extensionAttributes
    ) {
        return $this->_setExtensionAttributes($extensionAttributes);
    }

    /**
     * Get schedule_log
     * @return string|null
     */
    public function getScheduleLog()
    {
        return $this->_get(self::SCHEDULE_LOG);
    }

    /**
     * Set schedule_log
     *
     * @param  string  $scheduleLog
     *
     * @return \Mediastrategi\PostNord\Api\Data\ScheduleInterface
     */
    public function setScheduleLog($scheduleLog)
    {
        return $this->setData(self::SCHEDULE_LOG, $scheduleLog);
    }

    /**
     * Get schedule_added
     * @return string|null
     */
    public function getScheduleAdded()
    {
        return $this->_get(self::SCHEDULE_ADDED);
    }

    /**
     * Set schedule_added
     *
     * @param  string  $scheduleAdded
     *
     * @return \Mediastrategi\PostNord\Api\Data\ScheduleInterface
     */
    public function setScheduleAdded($scheduleAdded)
    {
        return $this->setData(self::SCHEDULE_ADDED, $scheduleAdded);
    }
}
