<?php

declare(strict_types=1);

namespace Mediastrategi\PostNord\Model\Data;

use Mediastrategi\PostNord\Api\Data\TransactionInterface;

class Transaction extends \Magento\Framework\Api\AbstractExtensibleObject implements TransactionInterface
{
    public function getOrderIds(): ?string
    {
        return $this->_get(self::ORDER_IDS);
    }

    public function setOrderIds(?string $orderIds): TransactionInterface
    {
        return $this->setData(
            self::ORDER_IDS,
            $orderIds
        );
    }

    public function getQuoteId(): ?string
    {
        return $this->_get(self::QUOTE_ID);
    }

    public function setQuoteId(?string $quoteId): TransactionInterface
    {
        return $this->setData(
            self::QUOTE_ID,
            $quoteId
        );
    }

    public function getShipmentIds(): ?string
    {
        return $this->_get(self::SHIPMENT_IDS);
    }

    public function setShipmentIds(?string $shipmentIds): TransactionInterface
    {
        return $this->setData(
            self::SHIPMENT_IDS,
            $shipmentIds
        );
    }

    public function getTransactionId(): ?int
    {
        return $this->_get(self::TRANSACTION_ID);
    }

    public function setTransactionId(?int $transactionId): TransactionInterface
    {
        return $this->setData(
            self::TRANSACTION_ID,
            $transactionId
        );
    }

    public function getRequestMethod(): ?string
    {
        return $this->_get(self::REQUEST_METHOD);
    }

    public function setRequestMethod(?string $requestMethod): TransactionInterface
    {
        return $this->setData(
            self::REQUEST_METHOD,
            $requestMethod
        );
    }

    public function getExtensionAttributes(): ?\Mediastrategi\PostNord\Api\Data\TransactionExtensionInterface
    {
        return $this->_getExtensionAttributes();
    }

    public function setExtensionAttributes(
        ?\Mediastrategi\PostNord\Api\Data\TransactionExtensionInterface $extensionAttributes
    ): TransactionInterface {
        return $this->_setExtensionAttributes($extensionAttributes);
    }

    public function getRequestUri(): ?string
    {
        return $this->_get(self::REQUEST_URI);
    }

    public function setRequestUri(?string $requestUri): TransactionInterface
    {
        return $this->setData(
            self::REQUEST_URI,
            $requestUri
        );
    }

    public function getRequestHeaders(): ?string
    {
        return $this->_get(self::REQUEST_HEADERS);
    }

    public function setRequestHeaders(?string $requestHeaders): TransactionInterface
    {
        return $this->setData(
            self::REQUEST_HEADERS,
            $requestHeaders
        );
    }

    public function getRequestBody(): ?string
    {
        return $this->_get(self::REQUEST_BODY);
    }

    public function setRequestBody(?string $requestBody): TransactionInterface
    {
        return $this->setData(
            self::REQUEST_BODY,
            $requestBody
        );
    }

    public function getResponseStatusCode(): ?int
    {
        return $this->_get(self::RESPONSE_STATUS_CODE);
    }

    public function setResponseStatusCode(?int $responseStatusCode): TransactionInterface
    {
        return $this->setData(
            self::RESPONSE_STATUS_CODE,
            $responseStatusCode
        );
    }

    public function getResponseBody(): ?string
    {
        return $this->_get(self::RESPONSE_BODY);
    }

    public function setResponseBody(?string $responseBody): TransactionInterface
    {
        return $this->setData(
            self::RESPONSE_BODY,
            $responseBody
        );
    }

    public function getResponseHeaders(): ?string
    {
        return $this->_get(self::RESPONSE_HEADERS);
    }

    public function setResponseHeaders(?string $responseHeaders): TransactionInterface
    {
        return $this->setData(
            self::RESPONSE_HEADERS,
            $responseHeaders
        );
    }

    public function getAdded(): ?string
    {
        return $this->_get(self::ADDED);
    }

    public function setAdded(?string $added): TransactionInterface
    {
        return $this->setData(
            self::ADDED,
            $added
        );
    }
}
