<?php

declare(strict_types=1);

namespace Mediastrategi\PostNord\Plugin\Order\Adminhtml;

class IgnoreAutomationBtn
{
    /**
     * @var \Magento\Framework\UrlInterface
     */
    private $backendUrl;

    /**
     * \Mediastrategi\PostNord\Helper\OrderData
     */
    private $orderDataHelper;

    public function __construct(
        \Mediastrategi\PostNord\Helper\OrderData $orderDataHelper,
        \Magento\Framework\UrlInterface $backendUrl
    ) {
        $this->backendUrl = $backendUrl;
        $this->orderDataHelper = $orderDataHelper;
    }

    public function beforeSetLayout(
        \Magento\Sales\Block\Adminhtml\Order\View $subject
    ): void {
        $toggleLink = $this->backendUrl->getUrl(
            'mspostnord/automation/ignore',
            ['order_id' => $subject->getOrderId()]
        );
        $orderId =
            (int) $subject->getOrderId();
        $orderData =
            $this->orderDataHelper->readData($orderId);

        $ignoreAutomation =
            !empty($orderData['ignoreAutomation']);
        $label = $ignoreAutomation
            ? __('Include in Automation')
            : __('Exclude from Automation');

        $subject->addButton(
            'ignore_automation',
            [
                'label'   => $label,
                'onclick' => "setLocation('" . $toggleLink . "')",
                'class'   => '',
            ]
        );
    }
}
