<?php

declare(strict_types=1);

namespace Mediastrategi\PostNord\Plugin;

class ShippingRatePlugin
{
    /**
     * @var \Mediastrategi\PostNord\Helper\Meta
     */
    private $metaHelper;

    public function __construct(
        \Mediastrategi\PostNord\Helper\Meta $metaHelper
    ) {
        $this->metaHelper = $metaHelper;
    }

    /**
     * @SuppressWarnings(PHPMD.UnusedFormalParameter)
     * phpcs:disable Generic.CodeAnalysis.UnusedFunctionParameter.FoundBeforeLastUsed
     */
    public function aroundImportShippingRate(
        \Magento\Quote\Model\Quote\Address\Rate $subject,
        callable $proceed,
        \Magento\Quote\Model\Quote\Address\RateResult\AbstractResult $rate
    ): \Magento\Quote\Model\Quote\Address\Rate {
        $result = $proceed($rate);
        if ($this->metaHelper->isEnabledForCheckout()) {
            $result->setMspostnordShipmentOptionId(
                $rate->getMspostnordShipmentOptionId()
            );
            $result->setMspostnordSelectedServicePoint(
                $rate->getMspostnordSelectedServicePoint()
            );
            $result->setMspostnordAvailableServicePoints(
                $rate->getMspostnordAvailableServicePoints()
            );
            $result->setMspostnordSelectedAddons(
                $rate->getMspostnordSelectedAddons()
            );
            $result->setMspostnordAvailableAddons(
                $rate->getMspostnordAvailableAddons()
            );
            $result->setMspostnordLongDescription(
                $rate->getMspostnordLongDescription()
            );
            $result->setMspostnordIsRecommended(
                $rate->getMspostnordIsRecommended()
            );
            $result->setMspostnordDeliveryEstimateText(
                $rate->getMspostnordDeliveryEstimateText()
            );
        }
        return $result;
    }
}
